<?php
/*---------------------------------------------------------------*/
/*
    Titre : Vérifier la validité d'une adresse URL.                                                                     
                                                                                                                          
    URL   : https://phpsources.net/code_s.php?id=92
    Date dition     : 08 Nov 2004                                                                                        
    Date mise  jour : 11 Aout 2019
                                                                                      
    Rapport de la maj:                                                                                                    
    - refactoring du code en PHP 7                                                                                        
    - fonctionnement du code vérifié                                                                                    
    - correction du code                                                                                                  
    - modification de la description                                                                                      
*/
/*---------------------------------------------------------------*/?>
Code 1

<?php 
//Vérifier la validité d'un adresse URL.
//Permet d'afficher un message si le lien d'une URL est valide ou non.
// L'URL du site web
$site = "http://www.phpsources.net";
$file = @fopen($site, 'r');
if ($file) 
{
echo 'URL valide !';
} 
else 
{
echo 'URL non valide !';
} 
?>

Code 2
<?php
function check_connect($host,$path)
//verifie la validite de l'adresse, c'est a dire on regarde si le site existe
// bien...
//on rend dans un tableau :
// "statut" : 0 si KO, 1 si redirect ou bien pour faire passer en local, 2 si OK
// "code" : code HTTP
// "message" : message
{
 
    $connect = 0;
    $no_code = 0;
    //connexion par socket
    if ($fp = fsockopen($host,80))
    {
        //traitement du path
        if(substr($path,strlen($path)-1) != '/')
        {
            if(!preg_match("#\.#",$path))
                $path .= "/";
        }
        //envoi de la requete HTTP
        fputs($fp,"GET ".$path." HTTP/1.1\r\n");
        fputs($fp,"Host: ".$host."\r\n");
        fputs($fp,"Connection: close\r\n\r\n");
        //on lit le fichier
        $line = fread($fp,255);
        $en_tete = $line;
        //on lit tant qu'on n'est pas la fin du fichier ou
        // qu'on trouve le debut du code html...
        while (!feof($fp) && !preg_match("#<#",$line) )
        {
            $en_tete .= $line;
            $line = fread($fp,255);
        }
        fclose($fp);
        //on switch sur le code HTTP renvoye
        $no_code = substr($en_tete,9,3);
        switch ($no_code)
        {
            // 2** la page a été trouvée
            case 200 :    $message = "OK";
                        $color = "#33cc00";
                        $connect = 2;
                        break;
            case 204 :    $message = "Cette page ne contient rien! (204)";
                        $color = "#ff9966";
                        break;
            case 206 :    $message = "Contenu partiel de la page! (206)";
                        $color = "#ff9966";
                        break;
            // 3** il y a une redirection
            case 301 : $message = 
"La page a été déplacéé définitivement!(301)";
 
                        $color = "#ff9966";
                        $connect = 1;
                        break;
            case 302 :  $message = 
"La page a été déplacéé momentanément!(302)";
 
                        $color = "#ff9966";
                        $connect = 1;
                        break;
            // 4** erreur du coté du client
            case 400 :    $message = "Erreur dans la requête HTTP! (400)";
                        $color = "#ff0000";
                        break;
            case 401 :    $message = "Authentification requise! (401)";
                        $color = "#ff0000";
                        break;
            case 402 :    $message = "L'accès à la page est payant! (402)";
                        $color = "#ff0000";
                        break;
            case 403 :    $message = "Accès à la page refusé! (403)";
                        $color = "#ff0000";
                        break;
            case 404 :    $message = "Page inexistante! (404)";
                        $color = "#ff0000";
                        break;
            // 5** erreur du coté du serveur
            case 500 :    $message = "Erreur interne au serveur! (500)";
                        $color = "#ff0000";
                        $connect = 1;
                        break;
            case 502 :  $message = "Erreur cause passerelle du serveur! (502)";
                        $color = "#ff0000";
                        break;
            // cas restant
            default : $message = 
"Erreur non traitée -> numéro est : $no_code!";
                        $color = "#000000";
                        break;
        }
    }
    else
    {
        $message = "Impossible de se connecter par socket";
        $color = "#ff0000";
    }
  //creation du tableau avec les valeurs a rendre
  $data_return["statut"] = $connect; //la page est OK ou KO (200 => OK sinon KO)
  $data_return["code"] = $no_code; //code HTTP renvoye
  $data_return["message"] = "<font color=\"".$color."\">".$message."</font>\n";
  return $data_return;
}
// utilisation
            $url = "http://phpsources.org/";
            $url_parsee = parse_url($url);  
            $host = $url_parsee["host"];
            $path = isset($url_parsee["path"]) ? trim($url_parsee['path']) : '';
            $tab_return = check_connect($host,$path);
            echo $tab_return["message"];
 
    // affiche
    // Code 1 URL valide
    // !Code 2 La page a été déplacée définitivement!(301)
?> 
